(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.1'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     55657,       1403]*)
(*NotebookOutlinePosition[     56320,       1426]*)
(*  CellTagsIndexPosition[     56276,       1422]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["M\[EAcute]lyszemantik\[AAcute]j\[UAcute] indexel\[EAcute]s Mathematic\
\[AAcute]val", "Title"],

Cell["\<\
Wittek P\[EAcute]ter
Budapesti M\[UDoubleAcute]szaki \[EAcute]s Gazdas\[AAcute]gtudom\[AAcute]nyi \
Egyetem
Matematikus szak, 3. \[EAcute]vfolyam
M\[UDoubleAcute]szaki menedzser szak, 5. \[EAcute]vfolyam\
\>", \
"Subsubsection"],

Cell[CellGroupData[{

Cell["Bevezet\[EAcute]s", "Section"],

Cell[TextData[{
  "A m\[EAcute]lyszemantik\[AAcute]j\[UAcute] indexel\[EAcute]s egy angol \
nyelv\[UDoubleAcute] sz\[ODoubleDot]vegek eset\[EAcute]n bev\[AAcute]lt, \
vektort\[EAcute]r modellen alapul\[OAcute] sz\[ODoubleDot]vegb\[AAcute]ny\
\[AAcute]szati elj\[AAcute]r\[AAcute]s. Magyar nyelv\[UDoubleAcute] sz\
\[ODoubleDot]vegeken t\[ODoubleDot]rt\[EAcute]n\[ODoubleAcute] tesztel\
\[EAcute]s\[EAcute]t egy hiedelrmsz\[ODoubleDot]vegekb\[ODoubleAcute]l \
\[AAcute]ll\[OAcute] gy\[UDoubleAcute]jtem\[EAcute]nyen teszteltem.  Az elj\
\[AAcute]r\[AAcute]s magva egy egyszer\[UDoubleAcute]s\[IAcute]t\[EAcute]s, \
rangredukci\[OAcute]. Rangredukci\[OAcute]t sokf\[EAcute]lek\[EAcute]ppen v\
\[EAcute]gezhet\[UDoubleDot]nk, egy a lehets\[EAcute]ges m\[OAcute]dszerek k\
\[ODoubleDot]z\[UDoubleDot]l a szingul\[AAcute]ris \[EAcute]rt\[EAcute]kek \
szerinti felbont\[AAcute]s. A ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " szerepe els\[OTilde]dlegesen a felbont\[AAcute]s \
elv\[EAcute]gz\[EAcute]se, a dolgozat az ebben szerzett tapasztalataimat r\
\[ODoubleDot]gz\[IAcute]ti."
}], "Text",
  TextJustification->1]
}, Closed]],

Cell[CellGroupData[{

Cell["Hiedelemsz\[ODoubleDot]vegek vektort\[EAcute]rmodellje", "Section"],

Cell[CellGroupData[{

Cell["A vektort\[EAcute]rmodell", "Subsection"],

Cell[TextData[{
  "A vektort\[EAcute]rmodell azon a felt\[EAcute]telez\[EAcute]sen alapul, \
hogy a sz\[ODoubleDot]vegek tartalma megragadhat\[OAcute] a \
benn\[UDoubleDot]k szerepl\[ODoubleAcute] szavak alapj\[AAcute]n. Ez a felt\
\[EAcute]telez\[EAcute]s Wittgensteinhez k\[ODoubleDot]thet\[ODoubleAcute], \
\[AAcute]ll\[IAcute]t\[AAcute]sa szerint ",
  StyleBox["meaning is use",
    FontSlant->"Italic"],
  ", a sz\[OAcute] jelent\[EAcute]se \[EAcute]ppen a haszn\[AAcute]lat\
\[AAcute]ban, a sz\[UDoubleAcute]ken \[EAcute]s t\[AAcute]gabban \
\[EAcute]rtelmezett kontextus\[AAcute]ban rejlik. Az elm\[EAcute]letnek sok k\
\[ODoubleDot]vet\[ODoubleAcute]je akadt, de meg kell jegyezn\[UDoubleDot]nk, \
hogy sok elt\[EAcute]r\[ODoubleAcute] jelent\[EAcute]selm\[EAcute]let l\
\[EAcute]tezik, \[EAcute]s ezek k\[ODoubleDot]z\[UDoubleDot]l nem \
mindegyiknek felel meg a vektort\[EAcute]rmodell \[EAcute]s \
lesz\[AAcute]rmazottai. A modell a sz\[ODoubleDot]veges adatb\[AAcute]zisb\
\[OAcute]l l\[EAcute]trehoz egy \[LongDash] jellemz\[ODoubleAcute]en val\
\[OAcute]s \[LongDash] m\[AAcute]trixot. Az oszlopokhoz dokumentumokat rendel \
hozz\[AAcute], a sorokhoz kifejez\[EAcute]seket. A kifejez\[EAcute]s fogalma \
nem egy\[EAcute]rtelm\[UDoubleAcute], kicsit \[AAcute]ltal\[AAcute]nosabban a \
dokumentumokban megfigyelhet\[ODoubleAcute] tulajdons\[AAcute]gokat \
\[EAcute]rtj\[UDoubleDot]k ide, ezek lehetnek p\[EAcute]ld\[AAcute]ul \
kulcsszavak. A m\[AAcute]trix egy eleme legegyszer\[UDoubleAcute]bb esetben \
azt jelzi, hogy az adott sorhoz rendelt kifejez\[EAcute]s \
el\[ODoubleAcute]fordul-e az adott oszlophoz rendelt dokumentumban, az eredm\
\[EAcute]ny egy bin\[AAcute]ris m\[AAcute]trix. Enn\[EAcute]l \[AAcute]ltal\
\[AAcute]ban jobb eredm\[EAcute]nyeket szolg\[AAcute]ltat, ha a \
m\[AAcute]trixban a kifejez\[EAcute]sek el\[ODoubleAcute]fordul\[AAcute]si \
gyakoris\[AAcute]gai (",
  Cell[BoxData[
      \(TraditionalForm\`f\_ij\)]],
  ", az ",
  Cell[BoxData[
      \(TraditionalForm\`i\)]],
  "-edik sz\[OAcute] ",
  Cell[BoxData[
      \(TraditionalForm\`j\)]],
  "-edik  dokumentumban val\[OAcute] gyakoris\[AAcute]ga) szerepelnek, vagy \
ezek logaritmusai ",
  Cell[BoxData[
      FormBox[
        RowBox[{
          RowBox[{"(", 
            RowBox[{\(log\_2\), "(", 
              RowBox[{
                SubscriptBox[
                  StyleBox["f",
                    FontSlant->"Italic"], "ij"], "+", "1"}], ")"}], ")"}], 
          "."}], TraditionalForm]]],
  " Gyakran c\[EAcute]lszer\[UDoubleAcute] ezt a lok\[AAcute]lis \
t\[EAcute]nyez\[OTilde]t s\[UAcute]lyozni egy glob\[AAcute]lis t\[EAcute]nyez\
\[ODoubleAcute]vel, p\[EAcute]ld\[AAcute]ul egy eg\[EAcute]szs\[EAcute]g\
\[UDoubleDot]gyi adatb\[AAcute]zisban az ",
  StyleBox["orvos ",
    FontSlant->"Italic"],
  StyleBox["sz\[OAcute] kev\[EAcute]s inform\[AAcute]ci\[OAcute]t hordoz, ez\
\[EAcute]rt a fontoss\[AAcute]g\[AAcute]t cs\[ODoubleDot]kkenteni lehet a \
vektort\[EAcute]rben (egy lehets\[EAcute]ges glob\[AAcute]lis s\[UAcute]lyoz\
\[AAcute]s: ",
    FontVariations->{"CompatibilityType"->0}],
  Cell[BoxData[
      \(TraditionalForm\`\(log\_2\) n\/n\_i + 1\)]],
  ", ahol ",
  Cell[BoxData[
      \(TraditionalForm\`n\)]],
  " a dokumentumok sz\[AAcute]ma, ",
  Cell[BoxData[
      \(TraditionalForm\`n\_i\)]],
  " azon dokumentumok sz\[AAcute]ma, amelyekben az ",
  Cell[BoxData[
      \(TraditionalForm\`i\)]],
  " kifejez\[EAcute]s el\[ODoubleAcute]fordul)."
}], "Text",
  TextJustification->1],

Cell[TextData[{
  "A m\[AAcute]trix l\[EAcute]trehoz\[AAcute]s\[AAcute]val a \
sz\[ODoubleDot]vegb\[AAcute]ny\[AAcute]szati k\[EAcute]rd\[EAcute]sek \
geometriai s\[IAcute]kra terel\[ODoubleAcute]dnek. Dokumentumok hasonl\
\[OAcute]s\[AAcute]ga a hozz\[AAcute]juk rendelt oszlopvektorok \
t\[AAcute]vols\[AAcute]ga alapj\[AAcute]n jellemezhet\[ODoubleAcute], k\
\[EAcute]t kifejez\[EAcute]s k\[ODoubleDot]z\[ODoubleDot]tti kapcsolat er\
\[OTilde]ss\[EAcute]g\[EAcute]t pedig a sorvektoraik \
t\[AAcute]vols\[AAcute]ga adja meg. Meg kell azonban jegyezni,hogy a \
kapcsolat min\[ODoubleAcute]s\[EAcute]g\[EAcute]r\[ODoubleAcute]l nem kapunk \
k\[ODoubleDot]zvetlen inform\[AAcute]ci\[OAcute]t. A sz\[ODoubleDot]vegb\
\[AAcute]ny\[AAcute]szat gyakorlata ritk\[AAcute]n alkalmazza az euklid\
\[EAcute]szi t\[AAcute]vols\[AAcute]got, helyette gyakran haszn\[AAcute]latos \
a koszinuszos t\[AAcute]vols\[AAcute]g (",
  Cell[BoxData[
      \(TraditionalForm\`d(x, y) = cos\[Beta]\)]],
  ", ahol ",
  Cell[BoxData[
      \(TraditionalForm\`\[Beta]\)]],
  " a k\[EAcute]t vektor sz\[ODoubleDot]ge; ",
  Cell[BoxData[
      FormBox[
        RowBox[{"cos\[Beta]", "=", 
          
          FormBox[\(\(\[Sum]\+\(i\  = \ 1\)\%n\ \(x\_i\) y\_i\)\/\(\(|\)\(x || 
                    y\)\(|\)\)\),
            "TraditionalForm"]}], TraditionalForm]]],
  ", norm\[AAcute]lt vektorok eset\[EAcute]n a nevez\[ODoubleAcute] el is \
hagyhat\[OAcute]). A tov\[AAcute]bbiakban ezt a t\[AAcute]vols\[AAcute]got \
fogom haszn\[AAcute]lni, a ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " ",
  StyleBox["5.1",
    FontSlant->"Italic"],
  " ezt m\[AAcute]r be\[EAcute]p\[IAcute]tve tartalmazza (",
  StyleBox["CosineAngleDissimilarity",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  " f\[UDoubleDot]ggv\[EAcute]ny)."
}], "Text",
  TextJustification->1],

Cell["\<\
Ha a vektorok k\[ODoubleDot]zel vannak egym\[AAcute]shoz,a \
koszinuszos t\[AAcute]vols\[AAcute]g egyhez k\[ODoubleDot]zeli, \
oszlopvektorok eset\[EAcute]ben ez k\[EAcute]t dokumentum tartalmi hasonl\
\[OAcute]s\[AAcute]g\[AAcute]t, sorvektorok eset\[EAcute]ben a kifejez\
\[EAcute]sek k\[ODoubleDot]z\[ODoubleDot]tti kapcsolat er\[ODoubleAcute]ss\
\[EAcute]g\[EAcute]t fejezi ki.\
\>", "Text",
  TextJustification->1],

Cell[TextData[{
  "A vektort\[EAcute]r m\[AAcute]trixa rendszerint k\[ODoubleDot]zel maxim\
\[AAcute]lis rang\[UAcute] (vagyis a ",
  Cell[BoxData[
      FormBox[
        RowBox[{
          RowBox[{"rang", "(", 
            StyleBox["A",
              FontWeight->"Bold",
              FontSlant->"Plain"], ")"}], "=", \(min(m, n)\)}], 
        TraditionalForm]]],
  "),ahol ",
  Cell[BoxData[
      FormBox[
        StyleBox["A",
          FontWeight->"Bold",
          FontSlant->"Plain"], TraditionalForm]]],
  " vektort\[EAcute]r ",
  Cell[BoxData[
      \(TraditionalForm\`n\[Cross]m\)],
    FontSlant->"Italic"],
  "-es), ugyanis k\[EAcute]t (kifejez\[EAcute]sek szerint) egyforma \
dokumentum nem val\[OAcute]sz\[IAcute]n\[UDoubleAcute], ahogy k\[EAcute]t \
teljesen azonos jelent\[EAcute]s\[UDoubleAcute] kifejez\[EAcute]s sem \
gyakori."
}], "Text",
  TextJustification->1],

Cell[TextData[{
  "A m\[AAcute]trix jellemz\[OTilde]en ritka ([2] alapj\[AAcute]n az elemek \
kevesebb, mint 1%-a nem nulla), ha a dokumentumok nem hossz\[UAcute]ak, ekkor \
ugyanis egy dokumentum az indexel\[EAcute]sben szerepl\[OTilde] kifejez\
\[EAcute]sek k\[ODoubleDot]z\[UDoubleDot]l \[AAcute]ltal\[AAcute]ban csak \
keveset tartalmaz. ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " ",
  StyleBox["5",
    FontSlant->"Italic"],
  "-ben m\[AAcute]r lehet\[OTilde]s\[EAcute]g van ennek kihaszn\[AAcute]l\
\[AAcute]s\[AAcute]ra. A ",
  StyleBox["SparseArray", "MR",
    FontWeight->"Bold"],
  StyleBox[" ", "MR"],
  "be\[EAcute]p\[IAcute]tett f\[UDoubleDot]ggv\[EAcute]nnyel lehet ritka m\
\[AAcute]trixokat l\[EAcute]trehozni, ezek mem\[OAcute]riaig\[EAcute]nye t\
\[ODoubleDot]red\[EAcute]ke a norm\[AAcute]lisan (b\[AAcute]r t\[ODoubleDot]m\
\[ODoubleDot]r\[IAcute]tve) t\[AAcute]rolt m\[AAcute]trixok\[EAcute]nak."
}], "Text",
  TextJustification->1]
}, Open  ]],

Cell[CellGroupData[{

Cell["Hiedelemsz\[ODoubleDot]vegek indexel\[EAcute]se", "Subsection"],

Cell["\<\
A sz\[ODoubleDot]veghalmaz 2704 darab magyar nyelv\[UDoubleAcute] \
hiedelemsz\[ODoubleDot]vegb\[ODoubleAcute]l \[AAcute]llt. A hiedelmek \
\[EAcute]let\[UDoubleDot]k sor\[AAcute]n sokat v\[AAcute]ltoznak, t\
\[ODoubleDot]bb hiedelem kombin\[AAcute]l\[OAcute]d\[AAcute]s\[AAcute]b\
\[OAcute]l \[UAcute]jabb hiedelmek alakulhatnak ki, \[EAcute]s feltehet\
\[ODoubleAcute], hogy egyfajta evol\[UAcute]ci\[OAcute]n is \[AAcute]tesnek, \
n\[EAcute]melyek esetleg elt\[UDoubleAcute]nnek, m\[AAcute]sok fennmaradnak \
esetleg nem is egy form\[AAcute]ban, hanem t\[ODoubleDot]bb \
vari\[AAcute]nsban is felbukkannak. Az elemz\[EAcute]shez m\[AAcute]r \
rendelkez\[EAcute]semre \[AAcute]llt a vektort\[EAcute]r, ebben a szakaszban \
r\[ODoubleDot]viden ismertetem, hogyan k\[EAcute]sz\[UDoubleDot]lt el ([17] \
alapj\[AAcute]n).\
\>", "Text",
  TextJustification->1],

Cell["\<\
A vektort\[EAcute]r l\[EAcute]trehoz\[AAcute]sa el\[OTilde]tt a sz\
\[ODoubleDot]vegeket normaliz\[AAcute]lt\[AAcute]k, \
sz\[OAcute]t\[ODoubleDot]vezt\[EAcute]k, megadt\[AAcute]k a kulcsszavakat \
\[EAcute]s a tiltott szavakat. A normaliz\[AAcute]l\[AAcute]s sor\[AAcute]n a \
sz\[ODoubleDot]vegeket k\[EAcute]zzel \
sz\[OAcute]t\[ODoubleDot]vezt\[EAcute]k, a k\[UDoubleDot]l\[ODoubleDot]nb\
\[ODoubleDot]z\[ODoubleAcute] nyelvj\[AAcute]r\[AAcute]si \[EAcute]s helyes\
\[IAcute]r\[AAcute]si alakok k\[ODoubleDot]z\[UDoubleDot]l \
kiv\[AAcute]lasztott\[AAcute]k a kulcsszavakat, amelyek egys\[EAcute]gesen \
helyettes\[IAcute]tett\[EAcute]k a t\[ODoubleDot]bbi form\[AAcute]t. Egy p\
\[EAcute]lda kulcssz\[OAcute]ra, \[EAcute]s a hozz\[AAcute] tartoz\[OAcute] \
sz\[OAcute]alakokra:
#alkony
alkonyat
naplemente
naplement\[EAcute]ig
napnyugta
napnyugtakor
napsz\[AAcute]lat
napsz\[AAcute]llat
napsz\[AAcute]llatkor
napsz\[AAcute]llta
sz\[UDoubleDot]rk\[ODoubleDot]let

Ez a folyamat csak r\[EAcute]szben automatiz\[AAcute]lhat\[OAcute], \
p\[EAcute]ld\[AAcute]ul a nyelvj\[AAcute]r\[AAcute]si alakok egy g\[EAcute]pi \
sz\[OAcute]t\[ODoubleDot]vez\[OTilde]nek komoly gondot okoznak.  A \
kulcsszavak list\[AAcute]j\[AAcute]n k\[IAcute]v\[UDoubleDot]l l\[EAcute]tre \
kellett m\[EAcute]g hozni a tiltott szavak list\[AAcute]j\[AAcute]t is, \
amelyeket a sz\[ODoubleDot]vegekben nem kell figyelembe venni (p\[EAcute]ld\
\[AAcute]ul n\[EAcute]vm\[AAcute]sok).\
\>", "Text",
  TextJustification->1],

Cell[TextData[{
  "A folyamat innent\[OTilde]l automatikus, a kulcsszavak \[EAcute]s tiltott \
szavak figyelembev\[EAcute]tel\[EAcute]vel egy Perl szkript \
l\[EAcute]trehozta vektorteret, egy bin\[AAcute]ris \
kulcssz\[OAcute]-dokumentum m\[AAcute]trixot. A ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " lehet\[ODoubleAcute]s\[EAcute]get ad arra, hogy mindent egy \
k\[ODoubleDot]rnyezetben \[LongDash] ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " notebookban kezelj\[UDoubleDot]nk. A megl\[EAcute]v\[ODoubleAcute] Perl \
szkriptet a ",
  StyleBox["RunThrough", "MR",
    FontWeight->"Bold"],
  " utas\[IAcute]t\[AAcute]ssal a sz\[UDoubleDot]ks\[EAcute]ges \
param\[EAcute]terez\[EAcute]ssel futathatn\[AAcute]nk egy \
notebookb\[OAcute]l, hogy megkapjuk a m\[AAcute]trixot. M\[EAcute]gsem l\
\[AAcute]tom azonban c\[EAcute]lszer\[UDoubleAcute]nek a teljes folyamatot, a \
",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " nem sz\[ODoubleDot]vegb\[AAcute]ny\[AAcute]szatra val\[OAcute], a \
statisztikai elemz\[EAcute]sekhez p\[EAcute]ld\[AAcute]ul c\[EAcute]lszer\
\[UDoubleAcute]bb eleve statisztikai programcsomagokat haszn\[AAcute]lni, b\
\[AAcute]r hozz\[AAcute] kell tennem, a ",
  StyleBox["Mathematica ",
    FontSlant->"Italic"],
  "5.1-es verzi\[OAcute] nagyon sokat \[UAcute]j statisztikai \
f\[UDoubleDot]ggv\[EAcute]ny ismer, ezekkel is \[EAcute]rdemes lehet \
dolgozni. Ha feldolgoz\[AAcute]s sor\[AAcute]n l\[EAcute]trehozott \
m\[AAcute]trixokat m\[EAcute]gis fel akarjuk haszn\[AAcute]lni m\[AAcute]s \
programokban, \[UAcute]jabb probl\[EAcute]m\[AAcute]k mer\[UDoubleDot]lnek \
fel, ugyanis a ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " kev\[EAcute]s ki-, \[EAcute]s bemeneti form\[AAcute]tumot ismer, az \
adatcsere m\[AAcute]s alkalmaz\[AAcute]sokkal k\[ODoubleDot]r\[UDoubleDot]lm\
\[EAcute]nyes."
}], "Text",
  TextJustification->1]
}, Open  ]],

Cell[CellGroupData[{

Cell["Kor\[AAcute]bbi tapasztalatok", "Subsection"],

Cell["\<\
F\[ODoubleAcute]komponens-anal\[IAcute]zisen nyugv\[OAcute] m\
\[EAcute]lyszemantik\[AAcute]j\[UAcute] indexel\[EAcute]ssel m\[AAcute]r \
elemezt\[EAcute]k a sz\[ODoubleDot]vegeket [17]. Az anal\[IAcute]zis v\
\[EAcute]g\[EAcute]n el\[ODoubleAcute]\[AAcute]llt 520 darab \
f\[OTilde]komponens, ezeket mint mot\[IAcute]vumokat lehetett \
\[EAcute]rtelmezni. Az 520 dimenzi\[OAcute]s t\[EAcute]r kett\[OTilde], \
illetve h\[AAcute]rom dimenzi\[OAcute]ban t\[ODoubleDot]rt\[EAcute]n\
\[ODoubleAcute] megjelen\[IAcute]t\[EAcute]s\[EAcute]re is tettek javaslatok. \
N\[EAcute]mileg meglep\[ODoubleAcute], hogy \[EAcute]rtelmes \
eredm\[EAcute]nyek sz\[UDoubleDot]lettek, ugyanis a f\[OTilde]komponens anal\
\[IAcute]zis felt\[EAcute]telezi, hogy a koordin\[AAcute]t\[AAcute]k korrel\
\[AAcute]latlanok. Nem l\[AAcute]tom, hogy ezt b\[AAcute]rmi is biztos\
\[IAcute]tan\[AAcute]. \[CapitalEAcute]rdekesebb, hogy az elemz\[EAcute]s \
diszkr\[EAcute]t, s\[ODoubleAcute]t bin\[AAcute]ris eloszl\[AAcute]son t\
\[ODoubleDot]rt\[EAcute]nt, ez egy\[AAcute]ltal\[AAcute]n nem \[AAcute]ltal\
\[AAcute]nos, a f\[ODoubleAcute]komponens-anal\[IAcute]zist jellemz\
\[ODoubleAcute]en folytonos eloszl\[AAcute]sokon alkalmazz\[AAcute]k. Az \
eredm\[EAcute]nyek m\[EAcute]gis haszn\[AAcute]lhat\[OAcute]ak, ebb\
\[ODoubleAcute]l arra k\[ODoubleDot]vetkeztetek, hogy a m\[OAcute]dszer \
nagyon robusztus, hibat\[UDoubleAcute]r\[ODoubleAcute]. Klaszterez\[EAcute]si \
k\[IAcute]s\[EAcute]rlet is volt [14]. A hiedelemsz\[ODoubleDot]vegek nem \
bizonyultak j\[OAcute]l klaszterezhet\[ODoubleAcute] halmaznak,a sz\
\[ODoubleDot]vegek nagy r\[EAcute]sze egy klaszterbe ker\[UDoubleDot]lt, f\
\[UDoubleDot]ggetlen\[UDoubleDot]l az alkalmazott klaszterez\[ODoubleAcute] \
elj\[AAcute]r\[AAcute]st\[OAcute]l. A klaszterez\[ODoubleAcute]k \[EAcute]rz\
\[EAcute]kenyek az outlierekre, de ezek kisz\[UDoubleAcute]r\[EAcute]se sem \
hozott l\[AAcute]tv\[AAcute]nyos javul\[AAcute]st az eredm\[EAcute]nyekben. \
Ennek lehets\[EAcute]ges magyar\[AAcute]zata a v\[AAcute]ltoz\[OAcute]k nagy \
sz\[AAcute]ma a dokumentumokhoz k\[EAcute]pest, ez\[EAcute]rt a \
l\[EAcute]nyegi von\[AAcute]sok nem l\[AAcute]tszottak a rengeteg dimenzi\
\[OAcute]ban.\
\>", "Text",
  TextJustification->1]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Szingul\[AAcute]ris \[EAcute]rt\[EAcute]kek szerinti \
felbont\[AAcute]s", "Section"],

Cell[CellGroupData[{

Cell["A m\[AAcute]trix bet\[ODoubleDot]lt\[EAcute]se", "Subsection"],

Cell[TextData[{
  "A m\[AAcute]trixot eleve ritka m\[AAcute]trixk\[EAcute]nt \
import\[AAcute]lom. A bet\[ODoubleDot]lt\[EAcute]s ideje egy perc alatt van, \
",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " ",
  StyleBox["4-",
    FontSlant->"Italic"],
  "ben ez a m\[UDoubleAcute]velet negyven percig tartott, ott m\[EAcute]g nem \
volt ",
  StyleBox["SparseArray", "MR",
    FontWeight->"Bold"],
  " t\[IAcute]pus, a m\[AAcute]trixokat m\[EAcute]gis t\[ODoubleDot]m\
\[ODoubleDot]r\[IAcute]tve t\[AAcute]rolta, a jelens\[EAcute]get nem tudom \
megmagyar\[AAcute]zni. \[CapitalEAcute]rdemes megfigyelni a mem\[OAcute]riak\
\[EAcute]szlet v\[AAcute]ltoz\[AAcute]s\[AAcute]t is, a k\[EAcute]t ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " verzi\[OAcute] k\[ODoubleDot]z\[ODoubleDot]tt 100 Mbyte k\[UDoubleDot]l\
\[ODoubleDot]nbs\[EAcute]g van az ",
  StyleBox["5",
    FontSlant->"Italic"],
  "-\[ODoubleDot]s jav\[AAcute]ra."
}], "Text",
  TextJustification->1],

Cell[BoxData[{
    \(\(pathtomatrices = "\<~/bme/matematikus/szimp3/jtoth/\>";\)\), "\
\[IndentingNewLine]", 
    \(\(A = 
        SparseArray[Import[pathtomatrices <> "\<input.dat\>"]];\)\)}], "Input",\

  CellLabel->"In[1]:="],

Cell["\<\
A m\[AAcute]trix az elv\[AAcute]r\[AAcute]snak megfelel\[OTilde]en \
val\[OAcute]ban k\[ODoubleDot]zel teljes rang\[UAcute].\
\>", "Text"],

Cell[BoxData[{
    \(Dimensions[A]\), "\[IndentingNewLine]", 
    \(MatrixRank[A]\)}], "Input",
  CellLabel->"In[3]:="]
}, Open  ]],

Cell[CellGroupData[{

Cell["Szingul\[AAcute]ris felbont\[AAcute]s", "Subsection"],

Cell[TextData[{
  "Egy ",
  Cell[BoxData[
      FormBox[
        StyleBox["A",
          FontWeight->"Bold",
          FontSlant->"Plain"], TraditionalForm]]],
  " val\[OAcute]s (vagy komplex), ",
  Cell[BoxData[
      \(TraditionalForm\`m\[Cross]n\)]],
  "-es m\[AAcute]trixot az ",
  Cell[BoxData[
      \(TraditionalForm\`n\)]],
  "-dimenzi\[OAcute]s ",
  Cell[BoxData[
      \(TraditionalForm\`E\_n\)]],
  " eukl\[EAcute]deszi t\[EAcute]r ",
  Cell[BoxData[
      \(TraditionalForm\`m\)]],
  "-dimenzi\[OAcute]s ",
  Cell[BoxData[
      \(TraditionalForm\`E\_m\)]],
  " eukl\[EAcute]deszi t\[EAcute]rre val\[OAcute] line\[AAcute]ris lek\
\[EAcute]pez\[EAcute]sk\[EAcute]nt is \[EAcute]rtelmezhetj\[UDoubleDot]k \
[16]. Ekkor ",
  Cell[BoxData[
      FormBox[
        StyleBox["A",
          FontWeight->"Bold",
          FontSlant->"Plain"], TraditionalForm]]],
  " szingul\[AAcute]ris \[EAcute]rt\[EAcute]kei ",
  Cell[BoxData[
      FormBox[
        StyleBox["A",
          FontWeight->"Bold",
          FontSlant->"Plain"], TraditionalForm]]],
  " saj\[AAcute]t b\[AAcute]zis\[AAcute]nak meghat\[AAcute]roz\[AAcute]s\
\[AAcute]b\[OAcute]l ad\[OAcute]dnak, ahol ",
  Cell[BoxData[
      FormBox[
        StyleBox["A",
          FontWeight->"Bold",
          FontSlant->"Plain"], TraditionalForm]]],
  " saj\[AAcute]t b\[AAcute]zisa ",
  Cell[BoxData[
      \(TraditionalForm\`E\_n\)]],
  " t\[EAcute]r egy ortonorm\[AAcute]lt b\[AAcute]zisa, amelyre:"
}], "Text",
  TextJustification->1],

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        RowBox[{
          RowBox[{"\[LeftAngleBracket]", 
            RowBox[{
              StyleBox[
                SubscriptBox[
                  StyleBox["Au",
                    FontWeight->"Bold",
                    FontSlant->"Plain"], "i"],
                FontSlant->"Italic"], 
              StyleBox[",",
                FontSlant->"Italic"], 
              StyleBox[
                SubscriptBox[
                  StyleBox["Au",
                    FontWeight->"Bold"], "j"],
                FontSlant->"Plain"]}], "\[RightAngleBracket]"}], 
          "=", \(\(s\_i\^2\) \[Delta]\_ij\)}], TraditionalForm]]],
  ","
}], "Text",
  TextAlignment->Center],

Cell[TextData[{
  "ahol ",
  Cell[BoxData[
      \(TraditionalForm\`\[LeftAngleBracket]\(.\)\(\(,\)\(.\)\)\
\[RightAngleBracket]\)]],
  " jel\[ODoubleDot]li a skal\[AAcute]ris szorz\[AAcute]st, az ",
  Cell[BoxData[
      \(TraditionalForm\`s\_i\)]],
  " sz\[AAcute]mok a szingul\[AAcute]ris \[EAcute]rt\[EAcute]kek, ",
  Cell[BoxData[
      \(TraditionalForm\`\[Delta]\_ij\)]],
  "a Kronecker-delta. Tetsz\[ODoubleAcute]leges line\[AAcute]ris \
lek\[EAcute]pez\[EAcute]snek van saj\[AAcute]t b\[AAcute]zisa, amely ugyan \
nem egy\[EAcute]rtelm\[UDoubleAcute], de a szingul\[AAcute]ris \[EAcute]rt\
\[EAcute]kek egy\[EAcute]rtelm\[UDoubleAcute]ek. A szingul\[AAcute]ris \
\[EAcute]rt\[EAcute]keket c\[EAcute]lszer\[UDoubleAcute] rendezve kezelni (",
  Cell[BoxData[
      FormBox[
        RowBox[{
          RowBox[{
            FormBox[
              RowBox[{
                RowBox[{
                  FormBox[\(\(s\_1\)\(\[LessEqual]\)\),
                    "TraditionalForm"], \(s\_2\)}], "\[LessEqual]"}],
              "TraditionalForm"], "..."}], "\[LessEqual]", \(s\_r\)}], 
        TraditionalForm]]],
  ", ahol ",
  Cell[BoxData[
      \(TraditionalForm\`s\_r\)]],
  " az utols\[OAcute] nem nulla szingul\[AAcute]ris \[EAcute]rt\[EAcute]k, ",
  Cell[BoxData[
      \(TraditionalForm\`r\)]],
  " teh\[AAcute]t ",
  Cell[BoxData[
      FormBox[
        StyleBox["A",
          FontWeight->"Bold",
          FontSlant->"Plain"], TraditionalForm]]],
  " rangja).\nAz ",
  Cell[BoxData[
      FormBox[
        StyleBox["A",
          FontWeight->"Bold",
          FontSlant->"Plain"], TraditionalForm]]],
  " lek\[EAcute]pez\[EAcute]s adjung\[AAcute]ltja ",
  Cell[BoxData[
      FormBox[
        RowBox[{
          RowBox[{
            StyleBox["A",
              FontWeight->"Bold",
              FontSlant->"Plain"], 
            StyleBox["'",
              FontWeight->"Bold",
              FontSlant->"Italic"]}], ":", \(E\_m \[RightArrow] E\_n\)}], 
        TraditionalForm]]],
  " lek\[EAcute]pez\[EAcute]s, amelyre b\[AAcute]rmely ",
  Cell[BoxData[
      \(TraditionalForm\`E\_n\)]],
  "-beli x \[EAcute]s ",
  Cell[BoxData[
      \(TraditionalForm\`E\_m\)]],
  "-beli ",
  Cell[BoxData[
      \(TraditionalForm\`y\)]],
  " vektorok eset\[EAcute]n: "
}], "Text",
  TextJustification->1],

Cell[TextData[{
  "\[LeftAngleBracket]",
  StyleBox["Ax",
    FontWeight->"Bold"],
  StyleBox[",",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  StyleBox["y",
    FontWeight->"Bold"],
  StyleBox["\[RightAngleBracket]=\[LeftAngleBracket]",
    FontWeight->"Bold"],
  StyleBox["x,A'y",
    FontWeight->"Bold"],
  StyleBox["\[RightAngleBracket]",
    FontWeight->"Bold"]
}], "Text",
  TextAlignment->Center],

Cell[TextData[{
  "Az adjung\[AAcute]lt egy\[EAcute]rtelm\[UDoubleAcute]. Legyen ",
  Cell[BoxData[
      FormBox[
        RowBox[{
          FormBox[
            StyleBox[
              SubscriptBox[
                StyleBox["v",
                  FontSlant->"Plain"], "i"],
              FontWeight->"Bold"],
            "TraditionalForm"], "=", 
          RowBox[{
            StyleBox[
              SubscriptBox[
                StyleBox["Au",
                  FontWeight->"Bold",
                  FontSlant->"Plain"], "i"],
              FontSlant->"Italic"], "/", \(s\_i\)}]}], TraditionalForm]]],
  " (",
  Cell[BoxData[
      \(TraditionalForm\`i = 1, 2,  ... , r\)]],
  "), a nulla szingul\[AAcute]ris \[EAcute]rt\[EAcute]kekhez pedig ",
  Cell[BoxData[
      FormBox[
        StyleBox[
          SubscriptBox[
            StyleBox["v",
              FontSlant->"Plain"], "i"],
          FontWeight->"Bold"], TraditionalForm]]],
  " legyen olyan, hogy az el\[ODoubleAcute]\[AAcute]ll\[OAcute] ",
  Cell[BoxData[
      FormBox[
        StyleBox["V",
          FontWeight->"Bold",
          FontSlant->"Plain"], TraditionalForm]]],
  " ortonorm\[AAcute]lt legyen. Szeml\[EAcute]letesen ",
  Cell[BoxData[
      FormBox[
        StyleBox["V",
          FontWeight->"Bold",
          FontSlant->"Plain"], TraditionalForm]]],
  " azon oszlopvektorai, amelyek nem nulla szingul\[AAcute]ris \[EAcute]rt\
\[EAcute]khez tartoznak, a k\[EAcute]pt\[EAcute]r ortonorm\[AAcute]lt b\
\[AAcute]zis\[AAcute]t adj\[AAcute]k, ",
  Cell[BoxData[
      FormBox[
        StyleBox["U",
          FontWeight->"Bold",
          FontSlant->"Plain"], TraditionalForm]]],
  " nulla szingul\[AAcute]ris \[EAcute]rt\[EAcute]khez tartoz\[OAcute] \
oszlopvektorai pedig a lek\[EAcute]pez\[EAcute]s magj\[AAcute]nak ortonorm\
\[AAcute]lt b\[AAcute]zis\[AAcute]t adj\[AAcute]k meg. Ha ",
  Cell[BoxData[
      FormBox[
        StyleBox["S",
          FontWeight->"Bold",
          FontSlant->"Plain"], TraditionalForm]]],
  "-sel jel\[ODoubleDot]lj\[UDoubleDot]k azt az ",
  Cell[BoxData[
      \(TraditionalForm\`m\[Cross]n\)]],
  "-es m\[AAcute]trixot, amelynek diagon\[AAcute]lis\[AAcute]ban az ",
  Cell[BoxData[
      \(TraditionalForm\`s\_i\)]],
  " \[EAcute]rt\[EAcute]kek \[AAcute]llnak, \[EAcute]s a t\[ODoubleDot]bbi \
eleme 0, akkor ",
  Cell[BoxData[
      FormBox[
        StyleBox["A",
          FontWeight->"Bold",
          FontSlant->"Plain"], TraditionalForm]]],
  " szingul\[AAcute]ris \[EAcute]rt\[EAcute]kek szerinti felbont\[AAcute]sa \
alatt a k\[ODoubleDot]vetkez\[ODoubleAcute]alakot \
\[EAcute]rtj\[UDoubleDot]k:"
}], "Text",
  TextJustification->1],

Cell[TextData[Cell[BoxData[
    FormBox[
      RowBox[{
        StyleBox["A",
          FontWeight->"Bold",
          FontSlant->"Plain"], 
        StyleBox["=",
          FontWeight->"Bold"], 
        RowBox[{
          StyleBox["VSU",
            FontWeight->"Bold"], 
          StyleBox["'",
            FontWeight->"Bold",
            FontSlant->"Italic"]}]}], TraditionalForm]]]], "Text",
  TextAlignment->Center],

Cell[TextData[{
  "Ha \[EAcute]rdekl\[OTilde]d\[EAcute]s\[UDoubleDot]nket csak az ",
  Cell[BoxData[
      \(TraditionalForm\`r\)]],
  " sz\[AAcute]m\[UAcute] nem nulla szingul\[AAcute]ris \
\[EAcute]rt\[EAcute]kekre korl\[AAcute]tozzuk, akkor az ",
  Cell[BoxData[
      FormBox[
        StyleBox["U",
          FontWeight->"Bold",
          FontSlant->"Plain"], TraditionalForm]],
    FontWeight->"Bold",
    FontSlant->"Italic"],
  " \[EAcute]s ",
  Cell[BoxData[
      FormBox[
        StyleBox["V",
          FontWeight->"Bold",
          FontSlant->"Plain"], TraditionalForm]]],
  " m\[AAcute]trixb\[OAcute]l t\[ODoubleDot]bb vektor el is hagyhat\[OAcute], \
\[IAcute]gy a fenti szorzatban a t\[EAcute]nyez\[OTilde]k dimenzi\[OAcute]i \
rendre ",
  Cell[BoxData[
      \(TraditionalForm\`m\[Cross]r, \ r\[Cross]r, \ r\[Cross]n\)]],
  " is lehetnek. \[CapitalEAcute]rdemes megeml\[IAcute]teni,hogy a szingul\
\[AAcute]ris felbont\[AAcute]st sokkal \[AAcute]ltal\[AAcute]nosabban is ki \
lehet mondani. A leg\[AAcute]ltal\[AAcute]nosabb oper\[AAcute]torok, amelyek \
szingul\[AAcute]ris felbont\[AAcute]ssal rendelkeznek, a Hilbert-terek k\
\[ODoubleDot]z\[ODoubleDot]tt lek\[EAcute]pez\[OTilde] kompakt \
line\[AAcute]ris oper\[AAcute]torok [3]. Jel\[ODoubleDot]lje ",
  Cell[BoxData[
      FormBox[
        SubscriptBox[
          StyleBox["S",
            FontWeight->"Bold",
            FontSlant->"Plain"], "k"], TraditionalForm]],
    FontSlant->"Italic"],
  " azt a m\[AAcute]trixot, amely hasonl\[OAcute]an \[EAcute]p\[UDoubleDot]l \
fel, mint az ",
  Cell[BoxData[
      FormBox[
        StyleBox["S",
          FontWeight->"Bold",
          FontSlant->"Plain"], TraditionalForm]]],
  ", de csak az els\[OTilde] ",
  StyleBox["k",
    FontSlant->"Italic"],
  " legnagyobb szingul\[AAcute]ris \[EAcute]rt\[EAcute]ket tartalmazza. Ekkor \
",
  Cell[BoxData[
      FormBox[
        SubscriptBox[
          StyleBox["A",
            FontWeight->"Bold",
            FontSlant->"Plain"], "k"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      \(TraditionalForm\`k\)]],
  " rang\[UAcute] m\[AAcute]trix el\[ODoubleAcute]\[AAcute]ll ebben az \
alakban:"
}], "Text",
  TextJustification->1],

Cell[TextData[Cell[BoxData[
    FormBox[
      RowBox[{
        SubscriptBox[
          StyleBox["A",
            FontWeight->"Bold",
            FontSlant->"Plain"], "k"], 
        StyleBox["=",
          FontWeight->"Bold"], 
        RowBox[{
          SubscriptBox[
            StyleBox["VS",
              FontWeight->"Bold",
              FontSlant->"Plain"], "k"], 
          RowBox[{
            StyleBox["U",
              FontWeight->"Bold",
              FontSlant->"Plain"], 
            StyleBox["'",
              FontWeight->"Bold",
              FontSlant->"Italic"]}]}]}], TraditionalForm]],
  FontWeight->"Bold",
  FontSlant->"Italic"]], "Text",
  TextAlignment->Center],

Cell[TextData[{
  "Az ",
  Cell[BoxData[
      FormBox[
        SubscriptBox[
          StyleBox["A",
            FontWeight->"Bold",
            FontSlant->"Plain"], "k"], TraditionalForm]]],
  " m\[AAcute]trix az ",
  Cell[BoxData[
      FormBox[
        StyleBox["A",
          FontWeight->"Bold",
          FontSlant->"Plain"], TraditionalForm]]],
  " m\[AAcute]trixhoz a legkisebb n\[EAcute]gyzetek m\[OAcute]dszere szerint \
a legk\[ODoubleDot]zelebb \[AAcute]ll\[OAcute] ",
  Cell[BoxData[
      \(TraditionalForm\`k\)]],
  " rang\[UAcute] m\[AAcute]trix. A sz\[AAcute]m\[IAcute]t\[AAcute]sok sor\
\[AAcute]n ",
  Cell[BoxData[
      FormBox[
        StyleBox["V",
          FontWeight->"Bold",
          FontSlant->"Plain"], TraditionalForm]],
    FontSlant->"Italic"],
  "-b\[ODoubleAcute]l \[EAcute]s ",
  Cell[BoxData[
      FormBox[
        StyleBox["U",
          FontWeight->"Bold",
          FontSlant->"Plain"], TraditionalForm]]],
  "-b\[OAcute]l elhagyhat\[OAcute]ak azok a vektorok, amelyekhez az ",
  Cell[BoxData[
      FormBox[
        SubscriptBox[
          StyleBox["S",
            FontWeight->"Bold",
            FontSlant->"Plain"], "k"], TraditionalForm]]],
  "-ban nulla tartozik. \nA vektort\[EAcute]r modell m\[AAcute]trix\[AAcute]n \
v\[EAcute]grehajtva a szingul\[AAcute]ris felbont\[AAcute]st megkapjuk az \
\[UAcute]n. fogalmi (vagy szemantikus) teret. Az eredeti vektort\[EAcute]rhez \
k\[EAcute]pest a rangredukci\[OAcute]val elvesztetj\[UDoubleDot]k a kifejez\
\[EAcute]sek sokf\[EAcute]les\[EAcute]g\[EAcute]t, a jelent\[EAcute]sbeli \
\[AAcute]rnyalatokat. Cser\[EAcute]be \[LongDash] elvben \[LongDash] l\
\[AAcute]that\[OAcute]v\[AAcute] v\[AAcute]lik az a n\[EAcute]h\[AAcute]ny \
(jellemz\[ODoubleAcute]en n\[EAcute]h\[AAcute]ny sz\[AAcute]z) mesters\
\[EAcute]ges fogalom, melyekb\[OTilde]l a dokumentumok tartalma \
\[ODoubleDot]ssze\[AAcute]ll. Ez a rejtett, m\[EAcute]ly szemantika, amely a \
kontextusb\[OAcute]l emelkedik ki, \[EAcute]s az eredeti vektort\[EAcute]rben \
nem volt k\[ODoubleDot]zvetlen\[UDoubleDot]l jelen.\nA szingul\[AAcute]ris \
felbont\[AAcute]s rendszerint numerikusan sz\[AAcute]m\[IAcute]tjuk, ez\
\[EAcute]rt k\[ODoubleDot]nnyen megeshet, a felbont\[AAcute]s ut\[AAcute]n \
nem a teljes rangsz\[AAcute]mmal megegyez\[ODoubleAcute] \
sz\[AAcute]m\[UAcute] szingul\[AAcute]ris \[EAcute]rt\[EAcute]ket kapunk, \
mert megeshet, hogy a t\[UAcute]l kicsi numerikus \[EAcute]rt\[EAcute]keket a \
felbont\[OAcute] algoritmus null\[AAcute]nak tekinti. \
Sz\[AAcute]nd\[EAcute]kunk \[EAcute]ppen a rangredukci\[OAcute], \
ez\[EAcute]rt ez a pontatlans\[AAcute]g most megengedhet\[OTilde]. A ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " a szingul\[AAcute]ris \[EAcute]rt\[EAcute]keket az ",
  Cell[BoxData[
      FormBox[
        RowBox[{
          StyleBox["AA",
            FontWeight->"Bold",
            FontSlant->"Plain"], 
          StyleBox["'",
            FontWeight->"Bold",
            FontSlant->"Italic"]}], TraditionalForm]]],
  " n\[EAcute]gyzetes m\[AAcute]trix saj\[AAcute]t\[EAcute]rt\[EAcute]keinek \
n\[EAcute]gyzetgy\[ODoubleDot]keik\[EAcute]nt hat\[AAcute]rozza meg. A \
dokument\[AAcute]ci\[OAcute] meglehet\[ODoubleAcute]sen \
sz\[UDoubleAcute]kszav\[UAcute] az alkalmazott algoritmusokkal kapcsolatban, \
annyit lehet tudni, hogy a line\[AAcute]ris algebrai numerikus sz\[AAcute]m\
\[IAcute]t\[AAcute]sok a ny\[IAcute]lt forr\[AAcute]s\[UAcute], nem a GNU \
Public License-\[UDoubleAcute] Lapack csomagon alapulnak (l. ",
  ButtonBox["www.netlib.org",
    ButtonData:>{"www.netlib.org", None},
    ButtonStyle->"Hyperlink"],
  ").\nA felbont\[AAcute]s idej\[EAcute]t \[EAcute]rdemes m\[EAcute]rni. A ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " a sz\[AAcute]m\[IAcute]t\[AAcute]sainak idej\[EAcute]t nem val\[OAcute]s \
id\[OTilde]ben m\[EAcute]ri, hanem csak azt az id\[OTilde]t sz\[AAcute]molja, \
amikor a kernel t\[EAcute]nyleges dolgozott. Nem sz\[AAcute]molja hozz\
\[AAcute] p\[EAcute]ld\[AAcute]ul azt az id\[OTilde]t, amikor az \
oper\[AAcute]ci\[OAcute]s rendszer a virtu\[AAcute]lis \
mem\[OAcute]ri\[AAcute]val dolgozik. Ez az id\[OTilde] igen jelent\
\[ODoubleAcute]s, egyes m\[UDoubleAcute]veletek sor\[AAcute]n a fizikai mem\
\[OAcute]ria t\[ODoubleDot]bbsz\[ODoubleDot]r\[ODoubleDot]se volt a felhaszn\
\[AAcute]lt virtu\[AAcute]lis mem\[OAcute]ria."
}], "Text",
  TextJustification->1],

Cell[BoxData[
    \(<< Utilities`ShowTime`\)], "Input",
  CellLabel->"In[5]:="],

Cell[TextData[{
  "Maga a felbont\[AAcute]s igen lass\[UAcute] m\[UDoubleAcute]velet, a \
teljes felbont\[AAcute]s ak\[AAcute]r t\[ODoubleDot]bb mint egy \[OAcute]r\
\[AAcute]ig is tarthat. A felbont\[OAcute] f\[UDoubleDot]ggv\[EAcute]ny csak \
v\[EAcute]ges precizit\[AAcute]s\[UAcute] m\[AAcute]trixokon \
m\[UDoubleAcute]k\[ODoubleDot]dik, ez\[EAcute]rt \
sz\[UDoubleDot]ks\[EAcute]ges ",
  Cell[BoxData[
      FormBox[
        StyleBox["A",
          FontWeight->"Bold",
          FontSlant->"Plain"], TraditionalForm]]],
  StyleBox[" ",
    FontWeight->"Bold"],
  "numerikus ki\[EAcute]rt\[EAcute]kel\[EAcute]se. Kicsit zavar\[OAcute]an a \
m\[AAcute]trixok jel\[ODoubleDot]l\[EAcute]s\[EAcute]t a fentiekkel nem \
\[ODoubleDot]sszhangban, hanem ",
  Cell[BoxData[
      FormBox[
        StyleBox["U",
          FontWeight->"Bold",
          FontSlant->"Plain"], TraditionalForm]]],
  "-t \[EAcute]s ",
  Cell[BoxData[
      FormBox[
        StyleBox["V",
          FontWeight->"Bold",
          FontSlant->"Plain"], TraditionalForm]]],
  "-t felcser\[EAcute]lve haszn\[AAcute]lom. A felbont\[AAcute]s \
l\[EAcute]nyegesen gyorsabb, ha nincs \
sz\[UDoubleDot]ks\[EAcute]g\[UDoubleDot]nk az \[ODoubleDot]sszes szingul\
\[AAcute]ris \[EAcute]rt\[EAcute]kre. Most legfeljebb 600-ra lesz sz\
\[UDoubleDot]ks\[EAcute]g, a k\[ODoubleDot]vetkez\[ODoubleAcute] szakaszban \
fejtem ki, mi\[EAcute]rt."
}], "Text",
  TextJustification->1],

Cell[BoxData[
    \(\({u, w, v} = SingularValueDecomposition[N[A], 600];\)\)], "Input",
  CellLabel->"In[6]:="],

Cell[BoxData[
    \(\(Off[ShowTime];\)\)], "Input",
  CellLabel->"In[7]:="],

Cell["\<\
A szingul\[AAcute]ris \[EAcute]rt\[EAcute]kek m\[AAcute]trixa term\
\[EAcute]szetesen ritka, \[EAcute]rdemes kihaszn\[AAcute]lni ezt a tulajdons\
\[AAcute]got.\
\>", "Text"],

Cell[BoxData[
    \(\(w = SparseArray[w];\)\)], "Input",
  CellLabel->"In[8]:="],

Cell[TextData[{
  "\[CapitalEAcute]rdekes k\[EAcute]rd\[EAcute]s, hogy milyen \
form\[AAcute]tumban ments\[UDoubleDot]k el a m\[AAcute]trixokat. Ha a fenti m\
\[AAcute]trixokat m\[AAcute]s programban is haszn\[AAcute]lni k\[IAcute]v\
\[AAcute]njuk, akkor mindenk\[EAcute]ppen a csv (comma separated value) form\
\[AAcute]tumot javaslom. Most csak bels\[OTilde] \
felhaszn\[AAcute]l\[AAcute]sra mentem el a m\[AAcute]trixokat, ez\[EAcute]rt \
Matrix Market form\[AAcute]tumot haszn\[AAcute]lok. Ez a form\[AAcute]tum \
\[UAcute]j a ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " ",
  StyleBox["5-",
    FontSlant->"Italic"],
  "ben, a leggyorsabban \[EAcute]s a legkevesebb mem\[OAcute]ria felhaszn\
\[AAcute]l\[AAcute]s\[AAcute]val ment ebben a form\[AAcute]tumban. A ",
  StyleBox["4",
    FontSlant->"Italic"],
  "-es verzi\[OAcute]val ezen a ponton fel kellett adni a pr\[OAcute]b\
\[AAcute]lkoz\[AAcute]st, a ment\[EAcute]s semmilyen form\[AAcute]tumba nem \
mehetett v\[EAcute]gbe, az oper\[AAcute]ci\[OAcute]s rendszer a menteni pr\
\[OAcute]b\[AAcute]l\[OAcute] ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " ",
  StyleBox["Kernel",
    FontSlant->"Italic"],
  "t n\[EAcute]h\[AAcute]ny \[OAcute]ra ut\[AAcute]n egyszer\[UDoubleAcute]en \
kil\[OTilde]tte."
}], "Text",
  TextJustification->1],

Cell[BoxData[{
    \(\(Export[pathtomatrices <> "\<u.mtx\>", 
        u];\)\), "\[IndentingNewLine]", 
    \(\(Export[pathtomatrices <> "\<v.mtx\>", 
        v];\)\), "\[IndentingNewLine]", 
    \(\(Export[pathtomatrices <> "\<w.mtx\>", w];\)\)}], "Input",
  CellLabel->"In[9]:="]
}, Open  ]],

Cell[CellGroupData[{

Cell["Rangredukci\[OAcute]", "Subsection"],

Cell[TextData[{
  "Neh\[EAcute]z megmondani, hogy milyen \
m\[EAcute]rt\[EAcute]k\[UDoubleAcute] rangredukci\[OAcute]t hajtsunk v\
\[EAcute]gre, \[EAcute]n k\[EAcute]t hat\[AAcute]r k\[ODoubleDot]z\[EAcute] \
tudtam beszor\[IAcute]tani a lehets\[EAcute]ges m\[EAcute]rt\[EAcute]ket. A m\
\[EAcute]lyszemantik\[AAcute]j\[UAcute] indexel\[EAcute]s megalkot\[OAcute]i \
szerint a legjobb eredm\[EAcute]nyeket kett\[OTilde]-, \[EAcute]s \
h\[AAcute]romsz\[AAcute]z k\[ODoubleDot]z\[ODoubleDot]tti megmarad\[OAcute] \
rang eset\[EAcute]n kaphatjuk [10]. Az \[EAcute]rt\[EAcute]kel\[EAcute]shez \
angol nyelv\[UDoubleAcute] lexikoncikkeket dolgoztattak fel az indexel\
\[OTilde]vel, majd a TOEFL vizsga szinonimatesztj\[EAcute]n vizsg\[AAcute]lt\
\[AAcute]k az elj\[AAcute]r\[AAcute]s szinonimafelismer\[OTilde] \
k\[EAcute]pess\[EAcute]g\[EAcute]t. A fels\[OTilde] korl\[AAcute]tot [17] \
alapj\[AAcute]n \[AAcute]llap\[IAcute]tottam meg, a bin\[AAcute]ris vektort\
\[EAcute]rben a f\[OTilde]komponens anal\[IAcute]zis 520 f\[OTilde]komponenst \
\[AAcute]llap\[IAcute]tott meg, ez\[EAcute]rt egy kicsivel felette, 600-ban \
hat\[AAcute]roztam meg a maxim\[AAcute]lis rangot. A rangok \
negyvenes\[EAcute]vel n\[ODoubleDot]vekednek. A rang \
reduk\[AAcute]l\[AAcute]sa a hat\[AAcute]rok kijel\[ODoubleDot]l\[EAcute]se \
ut\[AAcute]n k\[EAcute]t f\[AAcute]zisban mehetett csak v\[EAcute]gbe, \
ugyanis a nagy precizit\[AAcute]s\[UAcute] m\[AAcute]trixok szorz\[AAcute]s\
\[AAcute]nak \[EAcute]s form\[AAcute]z\[AAcute]s\[AAcute]nak \
mem\[OAcute]riaig\[EAcute]nye t\[UAcute]l nagy, ez\[EAcute]rt nem \
aj\[AAcute]nlatos egyszerre kezelni a felbont\[AAcute]s h\[AAcute]rom t\
\[EAcute]nyez\[OTilde]j\[EAcute]t \[EAcute]s az \
eredm\[EAcute]nym\[AAcute]trixot. Els\[OTilde] l\[EAcute]p\[EAcute]sben a \
szingul\[AAcute]ris \[EAcute]rt\[EAcute]kek m\[AAcute]trix\[AAcute]t balr\
\[OAcute]l szoroztam meg. Sz\[UDoubleDot]ks\[EAcute]g volt egy seg\[EAcute]df\
\[UDoubleDot]ggv\[EAcute]nyre, ez a szingul\[AAcute]ris \
\[EAcute]rt\[EAcute]kek m\[AAcute]trix\[AAcute]t adja vissza, de csak a ",
  Cell[BoxData[
      \(TraditionalForm\`k\)]],
  " legnagyobb szingul\[AAcute]ris \[EAcute]rt\[EAcute]kkel."
}], "Text",
  TextJustification->1],

Cell[BoxData[
    \(KeepFirstk[M_, k_] := 
      M . DiagonalMatrix[
          Join[Table[1, {k}], 
            Table[0, {\(Dimensions[M[\([1]\)]]\)[\([1]\)] - k}]]]\)], "Input",\

  CellLabel->"In[12]:="],

Cell[TextData[{
  "Ezeket a m\[AAcute]trixokat m\[EAcute]g mindig csak a ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " fogja haszn\[AAcute]lni, ez\[EAcute]rt Matrix Market form\[AAcute]tumban \
mentek."
}], "Text",
  TextJustification->1],

Cell[BoxData[{
    \(\(On[ShowTime];\)\), "\[IndentingNewLine]", 
    \(\(\(Export[
            pathtomatrices <> "\<reducedleft\>" <> ToString[#] <> "\<.mtx\>", 
            u . KeepFirstk[w, #]] &\) /@ Range[200, 600, 40];\)\)}], "Input",
  CellLabel->"In[13]:="],

Cell[TextData[{
  "Furcsa \[EAcute]s radik\[AAcute]lis megold\[AAcute]s, de ki kell \
l\[EAcute]pni a kernelb\[OTilde]l. M\[AAcute]s m\[OAcute]don (pl. ",
  StyleBox["Clear",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  StyleBox[",",
    FontFamily->"Courier"],
  StyleBox[" ClearAll",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  StyleBox[",",
    FontFamily->"Courier"],
  StyleBox[" Remove",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ") nem szabadul fel a v\[AAcute]ltoz\[OAcute]k \[AAcute]ltal felhaszn\
\[AAcute]lt mem\[OAcute]ria, \[IAcute]gy viszont azonnal."
}], "Text",
  TextJustification->1],

Cell[BoxData[
    \(\(Quit[];\)\)], "Input",
  CellLabel->"In[15]:="],

Cell["\<\
N\[EAcute]h\[AAcute]ny m\[UDoubleAcute]veletet meg kell \
ism\[EAcute]telni, \[EAcute]s be kell t\[ODoubleDot]lteni a a jobboldali \
szingul\[AAcute]ris vektorokat.\
\>", "Text"],

Cell[BoxData[{
    \(\(pathtomatrices = "\<~/bme/matematikus/szimp3/jtoth/\>";\)\), "\
\[IndentingNewLine]", 
    \(\(v = 
        Import[pathtomatrices <> "\<v.mtx\>"];\)\), "\[IndentingNewLine]", 
    \(<< Utilities`ShowTime`\)}], "Input",
  CellLabel->"In[1]:="],

Cell[TextData[{
  "Ezek ut\[AAcute]n l\[EAcute]tre lehet hozni a teljes, reduk\[AAcute]lt \
rang\[UAcute] m\[AAcute]trixokat. Sajnos semmilyen er\[ODoubleAcute]forr\
\[AAcute]s-felhaszn\[AAcute]l\[AAcute]st cs\[ODoubleDot]kkent\[OTilde] fog\
\[AAcute]s (",
  StyleBox["MemoryConserve",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  StyleBox[" ",
    FontFamily->"Courier"],
  "vagy ",
  StyleBox["Share",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  " ) nem ad \[EAcute]rtekelhet\[OTilde] megtakar\[IAcute]t\[AAcute]st. Nehez\
\[IAcute]ti a helyzetet, hogy ezeket a m\[AAcute]trixokat m\[AAcute]r m\
\[AAcute]s programokkal is meg kellene osztani, ez\[EAcute]rt a Matrix Market \
form\[AAcute]tum a tov\[AAcute]bbiakban nem aj\[AAcute]nlott. Tapasztalataim \
alapj\[AAcute]n a csv form\[AAcute]tum bizonyult hordozhat\[OAcute]nak, ezt \
az ",
  "SPSS",
  StyleBox[" ",
    FontSlant->"Italic"],
  "\[EAcute]s a ",
  "SAS/Enterprise Miner",
  " is kezelni tudta."
}], "Text",
  TextJustification->1],

Cell[BoxData[
    \(\(Export[
          pathtomatrices <> "\<reduced\>" <> 
            ToString[#] <> "\<.csv\>", \[IndentingNewLine]Import[
              pathtomatrices <> "\<reducedleft\>" <> 
                ToString[#] <> "\<.mtx\>"] . Transpose[v]] &\) /@ 
      Range[200, 600, 40]\)], "Input",
  CellLabel->"In[4]:="],

Cell["\<\
\[CapitalEAcute]rdemes a m\[AAcute]trixok transzpon\[AAcute]ltj\
\[AAcute]t is elt\[AAcute]rolni, mert m\[AAcute]s programok esetleg ezt \
esetleg magukt\[OAcute]l nem k\[EAcute]pesek elv\[EAcute]gezni, pedig \
megesik, hogy a transzpon\[AAcute]lttal kell dolgozni.\
\>", "Text",
  TextJustification->1],

Cell[BoxData[
    \(\(Export[
          pathtomatrices <> "\<reducedt\>" <> 
            ToString[#] <> "\<.csv\>", \[IndentingNewLine]Transpose[
            Import[pathtomatrices <> "\<reduced\>" <> 
                ToString[#] <> "\<.csv\>"]]] &\) /@ 
      Range[200, 600, 40]\)], "Input",
  CellLabel->"In[5]:="],

Cell["\<\
Ezzel a kulcssz\[OAcute]-dokumentum vektort\[EAcute]rb\[OTilde]l l\
\[EAcute]trej\[ODoubleDot]ttek a k\[UDoubleDot]l\[ODoubleDot]nb\[ODoubleDot]z\
\[OTilde] rang\[UAcute] fogalmi terek, minden sz\[UDoubleDot]ks\[EAcute]ges f\
\[AAcute]jl k\[EAcute]szen van. A mem\[OAcute]ri\[AAcute]t \[EAcute]rdemes \
felszabad\[IAcute]tani:\
\>", "Text",
  TextJustification->1],

Cell[BoxData[
    \(\(Quit[];\)\)], "Input",
  CellLabel->"In[6]:="]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Megjelen\[IAcute]t\[EAcute]s", "Section"],

Cell["\<\
A rangredukci\[OAcute] optim\[AAcute]lis m\[EAcute]rt\[EAcute]k\
\[EAcute]nek meghat\[AAcute]roz\[AAcute]sa nem a grafikus \
\[AAcute]br\[AAcute]zol\[AAcute]sok feladata, ez\[EAcute]rt ebben a \
r\[EAcute]szben egyetlen m\[AAcute]trixot fogok haszn\[AAcute]lni, a 200-ra \
cs\[ODoubleDot]kkentett rang\[UAcute]t. \
\>", "Text",
  TextJustification->1],

Cell[BoxData[{
    \(\(pathtomatrices = "\<~/bme/matematikus/szimp3/jtoth/\>";\)\), "\
\[IndentingNewLine]", 
    \(\(A = Import[pathtomatrices <> "\<reduced200.csv\>"];\)\)}], "Input",
  CellLabel->"In[1]:="],

Cell["\<\
Ha a 200 dimenzi\[OAcute]s teret meg lehetne jelen\[IAcute]teni, a \
dokumentumok keres\[EAcute]s\[EAcute]nek \[UAcute]j m\[OAcute]dja \
ny\[IAcute]lna meg, a mot\[IAcute]vumokb\[OAcute]l \
\[ODoubleDot]ssze\[AAcute]ll\[OAcute] vektorok k\[ODoubleDot]z\[UDoubleDot]l \
lehetne k\[ODoubleDot]nnyen tall\[OAcute]zni. Sajnos azonban be kell \
\[EAcute]rn\[UDoubleDot]nk kett\[Eth] \[EAcute]s \
h\[AAcute]romdimenzi\[OAcute]s \[AAcute]br\[AAcute]zol\[AAcute]sokkal. A \
fogalmi t\[EAcute]r egy lehets\[EAcute]ges megjelen\[IAcute]t\[EAcute]se h\
\[AAcute]rom dimenzi\[OAcute]ban, ha a dokumentumokat \[EAcute]s a \
kulcsszavakat az x \[EAcute]s y tengely ment\[EAcute]n felsorakoztatjuk, a \
fogalmi t\[EAcute]r m\[AAcute]trix\[AAcute]nak elemeit pedig m\[EAcute]lys\
\[EAcute]gkoordin\[AAcute]tak\[EAcute]nt \
\[EAcute]rtelmezz\[UDoubleDot]k.\
\>", "Text",
  TextJustification->1],

Cell[BoxData[
    \(ListPlot3D[
      A[\([Range[10]]\)], {ColorFunction \[Rule] Hue, Mesh \[Rule] False, 
        ViewPoint \[Rule] {2, 0.5, 1}}]\)], "Input",
  CellLabel->"In[3]:="],

Cell["\<\
Az \[AAcute]bra \[ODoubleDot]nmag\[AAcute]ban ugyan l\[AAcute]tv\
\[AAcute]nyos, de nem t\[UAcute]l hasznos. Ha m\[AAcute]s kiindul\[AAcute]si \
m\[AAcute]trixunk is van, p\[EAcute]ld\[AAcute]ul egy gyakoris\[AAcute]g \
\[EAcute]rt\[EAcute]keket tartalmaz\[OAcute], akkor ez az \[AAcute]bra eg\
\[EAcute]szen m\[AAcute]shogyan alakul, j\[OAcute]l elk\[UDoubleDot]l\
\[ODoubleDot]n\[UDoubleDot]l\[OTilde] v\[IAcute]zszintes plat\[OAcute]k l\
\[AAcute]that\[OAcute]ak rajta. Ez azt sejteti, ha a kiindul\[AAcute]si m\
\[AAcute]trixunk bonyolultabb statisztik\[AAcute]n alapul, a fogalmi t\
\[EAcute]r k\[ODoubleDot]nyebben kezelhet\[OTilde] lesz, a dokumentumok, \
illetve a fogalmak, mot\[IAcute]vumok \[EAcute]lesebben elv\[AAcute]lnak. Az \
\[AAcute]ll\[IAcute]t\[AAcute]s \
al\[AAcute]t\[AAcute]maszt\[AAcute]s\[AAcute]hoz \
sz\[UDoubleDot]ks\[EAcute]ges kimer\[IAcute]t\[OTilde]  vizsg\[AAcute]lat m\
\[EAcute]g v\[AAcute]rat mag\[AAcute]ra.
A mot\[IAcute]vumok k\[ODoubleDot]z\[UDoubleDot]l kett\[OTilde]t vagy h\
\[AAcute]rmat kiv\[AAcute]lasztva, azokat koordin\[AAcute]tatengelyekk\
\[EAcute]nt \[EAcute]rtelmezve kapjuk a k\[ODoubleDot]vetkez\[ODoubleAcute] \
\[AAcute]br\[AAcute]zol\[AAcute]st (ez egyfajta alacsony dimenzi\[OAcute]j\
\[UAcute] mot\[IAcute]vumt\[EAcute]r).\
\>", "Text",
  TextJustification->1],

Cell[BoxData[
    \(Show[
      Graphics3D[{PointSize[0.03], 
          Hue[1], \(Point[\(A[\([#]\)]\)[\([Range[3]]\)]] &\) /@ 
            Range[1000]}, {ViewPoint \[Rule] {2, 0.5, 1}, 
          Axes \[Rule] True}]]\)], "Input",
  CellLabel->"In[4]:="],

Cell["\<\
A mot\[IAcute]vumteres \[AAcute]br\[AAcute]zol\[AAcute]s esetleg \
seg\[IAcute]thet a dokumentumkeres\[EAcute]sben. A keres\[EAcute]s kezdetekor \
h\[AAcute]rom mot\[IAcute]vumot v\[AAcute]lasztva a fenti t\[EAcute]rb\
\[OTilde]l lehetne a lehets\[EAcute]ges tal\[AAcute]latok halmaz\[AAcute]t sz\
\[UDoubleAcute]k\[IAcute]teni, majd a sz\[UDoubleAcute]kebb halmazt \
m\[AAcute]sik h\[AAcute]rom mot\[IAcute]vum ter\[EAcute]ben \[AAcute]br\
\[AAcute]zolva lehetne a sz\[UDoubleAcute]k\[IAcute]t\[EAcute]st folytatni. \
Azonban az \[AAcute]bra nagyon sokat torz\[IAcute]t, 197 dimenzi\[OAcute] \
tartalma egyszer\[UDoubleAcute]en kiesik, nem tudunk r\[OAcute]luk semmit, ez\
\[EAcute]rt egy ilyen keres\[EAcute]s kimenetele esetleges.\
\>", "Text",
  TextJustification->1]
}, Closed]],

Cell[CellGroupData[{

Cell["Tov\[AAcute]bbi elemz\[EAcute]sek", "Section"],

Cell[TextData[{
  "Fontos lenne meghat\[AAcute]rozni a rangredukci\[OAcute] optim\[AAcute]lis \
m\[EAcute]rt\[EAcute]k\[EAcute]t. Ehhez sz\[UDoubleDot]ks\[EAcute]g van olyan \
mutat\[OAcute]sz\[AAcute]mokra, amelyek kifejezik egy adott rang\[UAcute] \
fogalmi t\[EAcute]r \"j\[OAcute]s\[AAcute]g\[AAcute]t\". A m\[AAcute]trixokat \
klaszterezve a klaszterez\[EAcute]s min\[ODoubleAcute]s\[EAcute]g\[EAcute]t \
vizsg\[AAcute]lva l\[EAcute]tre lehet hozni ilyen \
mutat\[OAcute]sz\[AAcute]mot, a klaszterez\[EAcute]st a ",
  StyleBox["Mathematica 5.1-",
    FontSlant->"Italic"],
  "ben bel\[UDoubleDot]l m\[AAcute]r k\[EAcute]nyelmesen el lehet \
v\[EAcute]gezni a ",
  StyleBox["ClusterAnalysis",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  " csomag seg\[IAcute]ts\[EAcute]g\[EAcute]vel. A klaszterelez\[EAcute]s \
jellemz\[EAcute]s\[EAcute]re \[IAcute]rni kell n\[EAcute]h\[AAcute]ny f\
\[UDoubleDot]ggv\[EAcute]nyt, mindez azonban m\[AAcute]r nem t\[EAcute]m\
\[AAcute]ja ennek a dolgozatnak.\nL\[EAcute]trehozhat\[OAcute] egy etalon \
keres\[EAcute]si k\[EAcute]rd\[EAcute]s halmaz, \[EAcute]s vizsg\[AAcute]lhat\
\[OAcute], hogy egy egyszer\[UDoubleAcute] keres\[ODoubleAcute] rendszer az \
adott rang\[UAcute] fogalmi t\[EAcute]ren milyen dokumentumhalmazt ad tal\
\[AAcute]latk\[EAcute]nt, \[EAcute]s ezzel jellemezn\[EAcute]nk a fogalmi \
teret. A ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " itt is szerepet kaphatna, a keres\[EAcute]st p\[EAcute]ld\[AAcute]ul a be\
\[EAcute]p\[IAcute]tett koszinuszos t\[AAcute]vols\[AAcute]gf\[UDoubleDot]ggv\
\[EAcute]nyre lehetne alapozni. A keres\[ODoubleAcute] ki\[EAcute]p\[IAcute]t\
\[EAcute]se azonban bonyolult feladat, \[EAcute]s t\[UAcute]lmutat a dolgozat \
keretein."
}], "Text",
  TextJustification->1]
}, Closed]],

Cell[CellGroupData[{

Cell["\[CapitalODoubleDot]sszefoglal\[AAcute]s", "Section"],

Cell[TextData[{
  "A ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " szerepe a m\[EAcute]lyszemantik\[AAcute]j\[UAcute] indexel\[EAcute]sben j\
\[OAcute]l k\[ODoubleDot]r\[UDoubleDot]lhat\[AAcute]rolhat\[OAcute]. Szingul\
\[AAcute]ris felbont\[AAcute]st elv\[EAcute]gezni kev\[EAcute]s program k\
\[EAcute]pes, a ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " ilyen, \[EAcute]s az 5-\[ODoubleDot]s verzi\[OAcute]ban egy ilyen m\
\[EAcute]ret\[UDoubleAcute] adatb\[AAcute]zis \
sz\[AAcute]m\[IAcute]t\[AAcute]sai is \[EAcute]rtelmes id\[OTilde] alatt elv\
\[EAcute]gezhet\[ODoubleAcute]ek. Statisztikai elemz\[EAcute]sekre egyre ink\
\[AAcute]bb alkalmas, ezen a t\[EAcute]ren a fejl\[OTilde]d\[EAcute]s \
rohamosnak t\[UDoubleAcute]nik. \[CapitalAAcute]br\[AAcute]zol\[AAcute]shoz, \
szeml\[EAcute]ltet\[EAcute]shez a ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " sz\[EAcute]les eszk\[ODoubleDot]zt\[AAcute]rral rendelkezik, ezek igen j\
\[OAcute]l haszn\[AAcute]lhat\[OAcute]ak."
}], "Text",
  TextJustification->1]
}, Closed]],

Cell[CellGroupData[{

Cell["Irodalomjegyz\[EAcute]k", "Section"],

Cell["\<\
[1] Berry, M.W., Drmac, Z., Jessup, E.R.: Matrices, vector spaces, \
and information retrieval. SIAM Review, 41(2), 1999, pp. 335-362.
[2] Berry, M.W., Dumais, S.T, O'Brien, G.W.: Using linear algebra for \
intelligent information retrieval. SIAM Review, 37(4), 1995, pp. 573-595.
[3] Bolla M.: Hilbert terek line\[AAcute]ris oper\[AAcute]torainak szingul\
\[AAcute]ris felbont\[AAcute]sa. Alkalmazott Matematikai Lapok, 13, 1987-88, \
Budapest.
[4] Dar\[AAcute]nyi S.: The necessity of a European virtual laboratory for \
the processing of digitized cultural heritage: The HOMO (Higher Order \
Morphologies' Observer) concept. In Dar\[AAcute]nyi, S. /Szerk./: \"HOMO 2003 \
\[LongDash] Information society, cultural heritage and folklore text analysis \
\[LongDash] Soci\[EAcute]t\[EAcute] de l'information, patrimoine culturel et \
analyse de textes folkloriques\", 2003. november 24-26., Budapest, pp. 72-77.
[5] Deerwester, S., Dumais, S.T, Furnas, G.W. : Indexing by latent semantic \
analysis. Journal of American Society for Information Science, 41(6), 1990, \
pp. 391-407.
[6] K\[EAcute]rchy L.: Hilbert terek oper\[AAcute]torai. SZTE Bolyai Int\
\[EAcute]zet, 2003, Szeged.
[7] Laham, D.: Latent semantic analysis approaches to categorization. In \
M.G.Schafto, P.Langley (Szerk.): Proceedings of the 19th Annual Meeting of \
the Cognitive Science Society, 1997, pp. 979.
[8] Landauer, T.K.: Applications of latent semantic analysis. 24th Annual \
Meeting of the Cognitive Science Society, 2002.
[9] Landauer, T.K, Dumais, S.T.: A solution to Plato's problem: The latent \
semantic analysis theory of the acquisition, induction, and representation of \
knowledge. Psychological Review, 104, 1997, pp. 211-240.
[10] Landauer, T.K., Foltz, P.W., Laham, D.: An introduction to latent \
semantic analysis. Discourse Processes, 25, 1998, pp. 259-284.
[11] Landauer, T.K., Laham, D., Foltz, P.W.: Learning human-like knowledge by \
singular value decomposition: a progress report. In M.I. Jordan,M.J. Koorns, \
S.A. Solla (Szerk.): Advances in Neural Information Processing Systems, 10, \
Cambridge:MIT Press, 1998, pp. 45-51.
[12] Letsche, T.A.: Toward large-scale information retrieval using latent \
semantic analysis. M.Sc. Thesis, University of Tenesse, Knoxville, 1996.
[13] Miller, T.: Latent semantic analysis and the construction of coherent \
extracts.
[14] Pozsonyi \[CapitalAAcute].: Dokumentumoszt\[AAcute]lyoz\[AAcute]si m\
\[OAcute]dszerek, \[EAcute]s azok \[UDoubleDot]zleti alkalmaz\[AAcute]sa. \
M.Sc. Thesis, BME, Budapest, 2004.
[15] Tak\[AAcute]cs G.: Sz\[ODoubleDot]vegb\[AAcute]ny\[AAcute]szat az \
adatvagyon \[UDoubleDot]zleti \[EAcute]rt\[EAcute]k\[EAcute]nek \
n\[ODoubleDot]vel\[EAcute]s\[EAcute]re. M.Sc.Thesis, BME, Budapest, 2004.
[16] Tusn\[AAcute]dy G.: M\[AAcute]trixok szingul\[AAcute]ris \
felbont\[AAcute]sa. Alkalmazott Matematikai Lapok, 5, 1979, Budapest, pp. \
375-384.
[17] Voigt V., Preminger M., L\[AAcute]di L., Dar\[AAcute]nyi S.: Automated \
motif identification in folklore text corpora. Folklore. An Electronic \
Journal of Folklore, 12, Tartu, 1999, pp. 126-141.\
\>", "Text",
  TextJustification->0]
}, Closed]]
}, Open  ]]
},
FrontEndVersion->"5.1 for X",
ScreenRectangle->{{0, 800}, {0, 600}},
WindowSize->{631, 558},
WindowMargins->{{-2, Automatic}, {Automatic, -2}},
StyleDefinitions -> "Textbook.nb"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 100, 1, 126, "Title"],
Cell[1879, 56, 238, 7, 84, "Subsubsection"],

Cell[CellGroupData[{
Cell[2142, 67, 36, 0, 85, "Section"],
Cell[2181, 69, 1126, 19, 88, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[3344, 93, 73, 0, 53, "Section"],

Cell[CellGroupData[{
Cell[3442, 97, 47, 0, 47, "Subsection"],
Cell[3492, 99, 3500, 73, 261, "Text"],
Cell[6995, 174, 1848, 41, 137, "Text"],
Cell[8846, 217, 429, 8, 40, "Text"],
Cell[9278, 227, 882, 26, 56, "Text"],
Cell[10163, 255, 969, 21, 88, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11169, 281, 69, 0, 47, "Subsection"],
Cell[11241, 283, 868, 14, 88, "Text"],
Cell[12112, 299, 1503, 33, 416, "Text"],
Cell[13618, 334, 1907, 40, 168, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[15562, 379, 51, 0, 47, "Subsection"],
Cell[15616, 381, 2259, 33, 200, "Text"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[17924, 420, 91, 1, 53, "Section"],

Cell[CellGroupData[{
Cell[18040, 425, 68, 0, 47, "Subsection"],
Cell[18111, 427, 984, 25, 72, "Text"],
Cell[19098, 454, 228, 6, 43, "Input"],
Cell[19329, 462, 148, 3, 24, "Text"],
Cell[19480, 467, 119, 3, 43, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[19636, 475, 59, 0, 47, "Subsection"],
Cell[19698, 477, 1493, 48, 56, "Text"],
Cell[21194, 527, 716, 22, 25, "Text"],
Cell[21913, 551, 2301, 68, 113, "Text"],
Cell[24217, 621, 410, 16, 24, "Text"],
Cell[24630, 639, 2654, 75, 104, "Text"],
Cell[27287, 716, 418, 14, 22, "Text"],
Cell[27708, 732, 2194, 61, 104, "Text"],
Cell[29905, 795, 687, 23, 22, "Text"],
Cell[30595, 820, 4420, 94, 320, "Text"],
Cell[35018, 916, 79, 2, 27, "Input"],
Cell[35100, 920, 1433, 35, 88, "Text"],
Cell[36536, 957, 111, 2, 27, "Input"],
Cell[36650, 961, 75, 2, 27, "Input"],
Cell[36728, 965, 183, 4, 24, "Text"],
Cell[36914, 971, 80, 2, 27, "Input"],
Cell[36997, 975, 1323, 30, 104, "Text"],
Cell[38323, 1007, 280, 6, 59, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[38640, 1018, 42, 0, 47, "Subsection"],
Cell[38685, 1020, 2226, 34, 184, "Text"],
Cell[40914, 1056, 205, 6, 59, "Input"],
Cell[41122, 1064, 251, 7, 40, "Text"],
Cell[41376, 1073, 265, 5, 59, "Input"],
Cell[41644, 1080, 632, 19, 40, "Text"],
Cell[42279, 1101, 69, 2, 27, "Input"],
Cell[42351, 1105, 188, 4, 24, "Text"],
Cell[42542, 1111, 265, 6, 59, "Input"],
Cell[42810, 1119, 1015, 27, 88, "Text"],
Cell[43828, 1148, 325, 7, 59, "Input"],
Cell[44156, 1157, 313, 6, 40, "Text"],
Cell[44472, 1165, 316, 7, 59, "Input"],
Cell[44791, 1174, 374, 7, 40, "Text"],
Cell[45168, 1183, 68, 2, 27, "Input"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[45285, 1191, 47, 0, 53, "Section"],
Cell[45335, 1193, 361, 7, 40, "Text"],
Cell[45699, 1202, 209, 4, 43, "Input"],
Cell[45911, 1208, 887, 15, 88, "Text"],
Cell[46801, 1225, 183, 4, 43, "Input"],
Cell[46987, 1231, 1330, 21, 128, "Text"],
Cell[48320, 1254, 254, 6, 75, "Input"],
Cell[48577, 1262, 781, 12, 72, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[49395, 1279, 52, 0, 53, "Section"],
Cell[49450, 1281, 1783, 32, 160, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[51270, 1318, 59, 0, 53, "Section"],
Cell[51332, 1320, 1052, 22, 88, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[52421, 1347, 42, 0, 53, "Section"],
Cell[52466, 1349, 3163, 50, 696, "Text"]
}, Closed]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

